#ifndef __CLASS_H__
#define __CLASS_H__

// Tm pit olla vasta lopussa, koska se tarvitsee CArchivea, perkele
#include "magic/pararr.h"
#include "magic/refarray.h"
//#include "magic/map.h"

// Externals
template<class K, class V> class Map;

//////////////////////////// CClass:Object //////////////////////////////////

class CClass;
class ClassLib;

// CClass on luokkien luokka. Se sislt joukon staattisia muuttujia, joiden
// avulla se pystyy rakentamaan enemmin tai vhemmn tydellisen
// ajonaikaisen luokkahierarkian. Pstkseen thn hierarkiaan mukaan
// on objektin toteutettava <I>decl_dynamic(luokka)</I> ja
// <I>impl_dynamic(luokka,is)</I>.
class CClass : public Object {
//	decl_dynamic (CClass)
	String				name;
	Array<String>		parents_unfound;
	CRefArray<CClass>	parents;
	//Object&				(Object::*mfpGetInstance) ();	// Instanssin luontihuukki
	GetClassInstance*	mGetInstance;
	friend ClassLib;
  public:

	// Empty constructor shouldn't be called ever....
					CClass		() {;}
					CClass		(const char* nam, const char* bases, GetClassInstance*);
					~CClass		();

	// Lis luokalle isn. Kyttkelpoinen moniperinnss
	void			addparent	(const char* nam) {;}

	// Palauttaa luokan nimen
	const String&	getname		() const {return name;}

	// Tulostaa luokan tiedot
	void			printclassinfo	(FILE* out=stdout) const;

	// Kertoo onko toinen objekti samaa luokkaa
	int				issameclass	(const Object& other) const {
		return this == (&other.getclass());
	}

	Object*			getInstance	() const {return mGetInstance->getInstance();}
};

class ClassLib : public Object {
	static Map<String,CClass>*	classes;
  public:
	static	void		printclassinfo	(const String& classname, FILE* out=stdout);
	static	Object&		getinstance		(const String& classname);
	static	CClass*		getclass		(const String& classname);
	static	void		insert			(CClass& cls);
};

#endif
