#include <object.h>
#include <cstring.h>
#include <magisupp.h>
#include <pararr.h>
#include <RegExp.h>

// impl_dynamic (RegExp, {Object});

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
/////////////////////////////// RegExp:Object ////////////////////////////////


RegExp::~RegExp () {
	if (regt) {
		regfree (regt);
		delete regt;
		regt=NULL;
	}
}

int RegExp::make (const char* expr) {
	this->~RegExp ();
	regt = new regex_t;

	if ((errcode = regcomp (regt, expr, REG_EXTENDED)))
		throw invalid_format (format ("%%%%%%RegExp Error:%s\n", (CONSTR) geterror ()));

	return errcode;
}
	
int RegExp::match (const char* str) {
	return !(errcode = regexec (regt, str, 0, NULL, REG_NOSUB));
}

int RegExp::match (const String& str, Array<String>& results) {
	regmatch_t matches [20];
	errcode = regexec (regt, str, 20, matches, 0);
	if (errcode) {
		if (errcode == REG_NOMATCH)
			return 0;
		else
			throw invalid_format (geterror());
	}

	int rescnt=0;
	for (; rescnt<19; rescnt++)
		if (matches[rescnt].rm_so>str.len || matches[rescnt].rm_eo>str.len ||
			matches[rescnt].rm_so<0 || matches[rescnt].rm_eo<0 ||
			matches[rescnt].rm_so > matches[rescnt].rm_eo)
			break;

	results.resize (rescnt);

	for (int i=0; i<rescnt; i++)
		results[i] = str.substr (matches[i].rm_so, matches[i].rm_eo-matches[i].rm_so);

	return 1;
}

String RegExp::geterror () const {
	char errbuf [256];
	regerror (errcode, regt, errbuf, 256);
	return errbuf;
}
