#include <attribute.h>
#include <map.h>

Attributed::Attributed () : mAttributes (NULL) {
}

Attributed::~Attributed () {
	delete mAttributes;
}

void Attributed::setAttribute (const String& key, Object* value) {
	if (!mAttributes)
		mAttributes = new Map<String,Object> ();
	mAttributes->set (key, value);
}

const Object& Attributed::getAttribute (const String& key) const {
	return mAttributes? (*mAttributes)[key] : *(Object*)NULL;
}

Object& Attributed::getAttribute	(const String& key) {
	return mAttributes? (*mAttributes)[key] : *(Object*)NULL;
}

const Object* Attributed::getAttributep (const String& key) const {
	return mAttributes? mAttributes->getp(key) : NULL;
}
