#ifndef __ATTRIBUTES_H__
#define __ATTRIBUTES_H__

#include <magic/object.h>
#include <magic/cstring.h>

// Externals
template<class K, class V> class Map;


/** Inheritable support for key-seekable dynamic attributes.
 **/
class Attributed {
  public:
					Attributed		();
					~Attributed		();
	
	/** Sets an attribute value, replaces possible old value.
	 *
	 *  Note: Takes ownership of the object.
	 **/
	void			setAttribute	(const String& key, Object* value);

	/** Returns attribute by given key. Const version.
	 **/
	const Object&	getAttribute	(const String& key) const;

	/** Returns attribute by given key. Non-const version.
	 **/
	Object&			getAttribute	(const String& key);

	/** Returns attribute by given key. Const version.
	 **/
	const Object*	getAttributep	(const String& key) const;

  private:
	Attributed	(const Attributed& orig) {FORBIDDEN}
	operator=	(const Attributed& orig) {FORBIDDEN}

	Map<String,Object>*	mAttributes;
};

#endif
