#include "magic/Class.h"
#include "magic/map.h"

/////////////////////////////  Class:Cobject  /////////////////////////////

//decl_dynamic (Class)

Class*	appclass = NULL;
Class*	taskclass = NULL;

//Class::Class (const char* nam, const char* bases, Object& (Object::*getinst)()){
Class::Class (const char* nam, const char* bases, GetClassInstance* getInstPtr){
	#ifdef MODULEDEBUG
	TRACE2 ("Class (%s, %s)", nam, bases);
	#endif
	name = nam;
	name.checksum ();
	// parents_unfound = new Array<String>;
	// parents = new CRefArray<Class>;
	//	getinstance = (Object&(Object::*getinst)()) ();
	//getinstance = (Object&(Object::*)()) getinst;
	mGetInstance = getInstPtr;

	if (bases) {
		String bases_str = bases;
		while (bases_str[0]=='{' || bases_str[0]=='"')
			bases_str = bases_str.substr (1);
		while (bases_str[bases_str.len-1]=='}' || bases_str[bases_str.len-1]=='"')
			bases_str.dellast (1);
		bases_str.split (parents_unfound, ',');
		for (int i=0; i<parents_unfound.size; i++) {
			if ((parents_unfound[i] == "Application" ||
				 parents_unfound[i] == "HTMLQuery") &&
				name != "HTMLQuery") {
				appclass = this;
				// TRACE2 ("Class (%s, %s)", nam, bases);
			}
			if (parents_unfound[i] == "Task")
				taskclass = this;
		}
	}

	// printclassinfo ();
	
	ClassLib::insert (*this);
}

Class::~Class () {
	// delete parents_unfound;
	// delete parents;
}

void Class::printclassinfo (FILE* out) const {
	fprintf (out, "class %s",
			(CONSTR) name);

	// Tulostetaan vanhemmat
	if (parents_unfound.size>0) {
		fprintf (out, ": ");
		for (int i=0; i<parents_unfound.size; i++) {
			fprintf (out, "%s", (CONSTR) parents_unfound[i]);
			if (i<parents_unfound.size-1)
				fprintf (out, ",");
		}
	}
	fprintf (out, " {\n");

	// Tulostetaan attribuutit

	// NOT WORKING TEMPORARILY!
	//Object* inst = (const_cast<Class*>(this)->getinstance ());
	Object* inst=NULL;

	DumpContext ar (out);
	ar << *inst;
	for (int i=0; i<ar.getattribs().size; i++)
		fprintf (out, "\t%s;\n", (CONSTR) ar.getattribs()[i]);
	delete inst;
	fprintf (out, "};\n");
}

/////////////////////////////  ClassLib:Object  /////////////////////////////

// Class* ClassLib::firstclass = NULL;
CMap<String,Class>* ClassLib::classes = NULL;

void ClassLib::printclassinfo (const String& classname, FILE* out) {
	const Class* cls = classes->getp (classname);
	if (cls)
		cls->printclassinfo (out);
}

Class* ClassLib::getclass (const String& classname) {
	return classes->getvp (classname);
}

Object& ClassLib::getinstance (const String& classname) {
	//TRACE1("%s", (CONSTR) classname);
	Class* cls = classes->getvp (classname);
	if (cls)
		return *cls->getInstance();
	TRACE1("%%ERROR: No instance for '%s' found", (CONSTR) classname);
	return *(Object*)NULL;
}

void ClassLib::insert (Class& cls) {
	if (!classes)
		classes = new CMap<String,Class> (256, MAP_REF);
	
	classes->set (cls.name, cls);

	// Haetaan luokan vanhemmat
	for (int i=0; i<cls.parents_unfound.size; i++)
		;
}
