#include "magic/object.h"
#include "magic/cstring.h"
#include "magic/Class.h"
#include "magic/RegExp.h"


#ifdef SunOS
#include <sys/varargs.h>
#else
#include <stdarg.h>
#endif



impl_dynamic (String, {Comparable})

/////////////////////////////  String:Object  /////////////////////////////

// len = "strlen(str)"
// maxlen > len
// LoppuNULL tulee aina mukaan


String::String () {
	len		= 0;
	maxlen	= 0;
	data	= NULL;
	chksum	= 0;
	//	locked	= 0;
}

String::String (const String& orig) {
	if (&orig == NULL || orig.data==NULL) {
		len = 0;
		maxlen = 0;
		data = NULL;
	//	locked = 0;
		return;
	}
	len = orig.len;
	maxlen = orig.maxlen;
	data = new char [maxlen+1];
	memcpy (data, orig.data, maxlen+1);
	chksum	= 0;
//	locked = orig.locked;
}

String::String (const char* chrp) {
	if (chrp) {
		len		= strlen (chrp);
		maxlen	= len;
		data	= new char [maxlen+1];
		memcpy (data, chrp, len+1);
	} else {
		len = maxlen = 0;
		data = NULL;
	}
	chksum	= 0;
//	locked	= 0;
}

String::String (const char* chrp, int n) {
	if (chrp && n) {
		len		= n;
		maxlen	= len;
		data	= new char [maxlen+1];
		memcpy (data, chrp, len);
		data [maxlen] = 0x00;
	} else {
		len = maxlen = 0;
		data = NULL;
	}
	chksum	= 0;
}

String::~String () {
	if (data) delete data;
	data = (char*) 0xdddddddd;
}

String::String (int i) {
	len = maxlen = 0;
	data = NULL;
	*this = format ("%d", i);
	chksum	= 0;
}

String::String (float f) {
	len = maxlen = 0;
	data = NULL;
	*this = format ("%f", f);
	chksum	= 0;
}

String::String (double f) {
	len = maxlen = 0;
	data = NULL;
	*this = format ("%lf", f);
	chksum	= 0;
}

String& String::assign (char c) {
	if (data)
		data = (char*) renew (data, 2);
	else
		data = new char [2];
	data[0]=c;
	data[1]=0;
	len = maxlen = 1;
	return *this;
}

String& String::operator= (const String& other) {
//	TRACELINE
//	TRACE1 ("%x\n", &other);
	if (data)
		delete data;
	if (&other == NULL || other.data==NULL) {
		len = maxlen = 0;
		data = NULL;
		chksum=0;
		return *this;
	}
	len = other.len;
	maxlen=other.maxlen;
	data = new char [maxlen+1];
	memcpy (data, other.data, len+1);	
	chksum = other.chksum;
	return *this;
}

String& String::operator= (const char* chrp) {
//	TRACELINE
	if (data)
		delete data;
	if (!chrp) {
		data	= NULL;
		len		= 0;
		maxlen	= 0;
		chksum	= 0;
		return *this;
	}
	len = maxlen = strlen (chrp);
	data = new char [maxlen+1];
	memcpy (data, chrp, len+1);
	chksum	= 0;
	return *this;
}

ostream& String::dump (ostream& out) const {
	out << format ("String #0x%x\n");
	out << "data=" << data << "\n";
	out << "len=" << len << "\n";
	out << "maxlen=" << maxlen << "\n";
	return out;
}

ostream& String::operator>> (ostream& out) const {
	out << data;
	return out;
}

istream& String::operator<< (istream& is) {
	len = 0; // Set size to 0. Warning! Uncommon access!
	if (data)
		data[0] = 0;
	ensure_spontane (80);
	
	int w = is.width (0);
	if (is.ipfx0 ()) {
		register streambuf *sb = is.rdbuf ();
		while (1) {
			int ch = sb->sbumpc ();
			if (ch == EOF) {
				is.setstate (ios::eofbit);
				break;
            } else if (isspace (ch)) {
				sb->sungetc ();
				break;
			}
			(*this) += ch;
			if (--w == 1)
				break;
        }
    }
	is.isfx ();
	if (len == 0) // Didn't read anything. This is a problem.
		is.setstate (ios::failbit);
 
	return is;
}

CArchive& String::operator>> (CArchive& arc) const {
	arc.name ("len") << len;
	arc.name ("maxlen") << maxlen;
	if (len)
		arc.name ("data").write (data, len+1);
	else
		arc.name ("data").write (data, 0);
	return arc;
}

IStream& String::operator<< (IStream& arc) {
	arc>>len;
	arc>>maxlen;
	delete data;
	data=NULL;
	chksum	= 0;
	if (len) {
		data = new char [maxlen+1];
		arc.read (data, len+1);
	}
	chksum=0;
	return arc;
}


String String::operator+ (const String& other) const return foo{
	foo = *this;
	foo += other;
}

String String::operator+ (const char* str) const return res {
	res=*this;
	res+=String(str);
}

String& String::dellast (int n) {
	if (n>=len) {
		if (data) {
			delete data;
			data = NULL;
			len = maxlen = 0;
		}
		return *this;
	}
	len -= n;
	// Hmm, miksiks tll on tllinen reallocci
	// data = (char*) realloc (data, len+1);
	data [len] = 0;
//	cout << format ("Dellast:%d\n", n);
	chksum=0;
	return *this;
}

void String::chop () {
	while (len>0 && isspace(data[len-1]))
		dellast (1);
	chksum=0;
}

void String::unquote (char quotechar, int flags) {
	enum	{Waiting, GotEqual, GotFirst, GotSoftLinebreak};
	String	hextable = "0123456789ABCDEF";
	int		state = Waiting,
			value = 0,
			respos = 0;

	// Merkkijono johon merkit knnksen jlkeen tallennetaan
	// ja kopioidaan tst lopussa takaisin.
	String tmp;
	tmp.reserve (len);

	// Kydn itsemme lpi
	for (int i=0 ; i<len ; i++) {
		char c=(*this)[i];
		switch (state) {
			case Waiting:
				if (c == quotechar)
					state=GotEqual;
				else
					if (c=='+' && (flags&QUOTE_HTML))
						tmp += ' ';
					else
						tmp += c;
				break;
			case GotEqual:
				if ((value=hextable.find(c)) != -1) {
					state=GotFirst;
					value*=16; // Shiftataan ylspin....
				} else { // Hmm, ei ollutkaan heksaluku...
					if (c=='\r') { // soft CRLF
						state = GotSoftLinebreak;
					} else {
						// Something weird...
						// Error in Q-P code! Let's recover it...
						state = Waiting;
						tmp += quotechar; 
						tmp += c;
					}
				}
				break;
			case GotFirst:
				if (hextable.find(c) != -1) {
					value+=hextable.find (c);
					tmp += char(value);
					state=Waiting; // Ok, palataan normaaliin tilaan...
				} else {
					// Jotain omituista, virhe QP-koodista.. yritetn toipua..
					tmp += quotechar;
					tmp += char(value);
					tmp += c;
					state = Waiting; // S vi ventar igen..
				}
				break;
			case GotSoftLinebreak:
				 // Hmm, se ei ollutkaan pehme rivinvaihto??
				 if (c!='\n')
					// no, yritetn toipua jollain lailla....
					tmp += c;
				state=Waiting;
				break;
		};
	}

	if (state!= Waiting) {
		// Hmm, siell oli siis lopussa yksininen '=' -> PANIC!
		tmp += '=';
		if (state==GotFirst)
			// DOUBLEPANIC!, mutta varaudutaan silti...
			// Hmm, tt ei pitisi tarvita tehd...
			tmp += char(hextable[state/16]);
	} // DON'T PANIC!

	// Laitetaan loppunulli
	// tmp += '\x00';
	// tmp.len = respos;

	(*this) = tmp;
}


String String::substr (int from, int n) const return result {
	// Jos pituus on -1, otetaan loput merkkijonosta
	if (n==-1)
		n = len-from;

	// Jos pyydetn merkkijonon ulkopuolelta tai tyhj jono
	if (from >= len || len==0)
		return;

	// Jos pyynt menee merkkijonon ulkopuolelle, pienennetn pyynt
	if (((from + n) > len))
		n = len-from;

	ASSERT (maxlen>=n);
	
	// Luodaan uusi merkkijono
	result.len = n;
	result.maxlen = maxlen;
	result.data = new char [maxlen+1];
	strncpy (result.data, data+from, n);
	result.data [n] = 0;
}

String String::left (int n) const {
	return substr (0, n);
}

String String::right (int n) const return result {
	if (n < len)
		result = substr (len-n);
	else
		result = *this;
}

int String::find (const String& subs, int n) const {
	for (int i=n; i <= (len-subs.len); i++)
		if (!strncmp (data+i, subs.data, subs.len))
			return i;
	return -1;
}

int String::find (const char c, int n) const {
	char* pos = (char*) memchr (data+n, c, len);
	return pos? pos-data : -1;
}

int String::rfind (const String& subs, int n) const {
	if (n<0)
		n+=len;
	for (int i=n; i>=0; i--)
		if (!strncmp (data+i, subs.data, subs.len))
			return i;
	return -1;
}


Object* String::clone () const {
	String* foo = new String (data);
	return foo;
}

String& String::operator+= (const String& other) {
	// Varmistutaan ettei toinen ole tyhj
	if (!other.len)
		return *this;

	// Varataan tilaa sopivasti
	if (len+other.len>maxlen)
		ensure (len+other.len+1);
	// Katenoidaan
	memcpy (data+len, other.data, other.len+1);
	// Kasvatetaan omaa pituutta
	len += other.len;
	// Laitetaan viel loppunulli pern
	data[len]='\x00';
	chksum=0;
	return *this;
}

int String::operator== (const char* other) const {
	if (!this)
		return 0;
	if (data && other)
		return (!strcmp (data, other));
	if ((!data) && (!other))
		return 1;
	return 0;
}

int String::operator== (const Comparable& other) const {
	if (getclass().issameclass (other))
		return operator== ((const String&) other);
	else
		return 0;
}

String& String::operator+= (char c) {
	ensure_spontane (len+1);
	data [len++] = c;
	data [len] = 0;
	chksum=0;
	return *this;
}

void String::reserve (int amount) {
	if (data) {
		char* newdata = new char [amount+1];
		if (!newdata)
			throw runtime_error ("Out of memory or something in String::reserve()");
		memcpy (newdata, data, len+1);
		delete data;
		data = newdata;
		data [amount] = 0x00;
	} else {
		data = new char[amount+1];
		if (!data)
			throw runtime_error ("Out of memory or something in String::reserve()");
		*data = 0x00;
	}
	maxlen = amount;
}

char hexcodes[] = "0123456789abcdef";

String& String::hexcode (const String& other) {
	reserve (other.len*2);
	for (int i=0; i<other.len; i++)
		*this += hexcodes [((unsigned int) other.data[i])/16],
		*this += hexcodes [((unsigned int) other.data[i])%16];
	chksum=0;
	return *this;
}

#include <stdio.h>

void String::split (Array<String>& trg, const char delim) const {
	if (!this || !len)
		return;
	char* tmp = new char [len+1];
	memcpy (tmp, data, len+1);
	tmp[len]=0;
	for (int i=0; i<len; i++)
		if (tmp[i]==delim)
			tmp[i]=0;
	trg.empty ();
	for (int pos = 0, i=0; pos<len; pos+=strlen (tmp+pos)+1, i++) {
		String tmps = tmp+pos;
		trg.put (tmps, i);
	}
	delete tmp;
}

void String::join (const Array<String>& src, const char delim) {
	// Lasketaan kohdemerkkijonon pituus tilanvarausta varten
	int newlen = src.size-1;
	for (int i=0; i<src.size; i++)
		newlen += src[i].len;

	// Varataan tila
	reserve (newlen);
	*this = "";

	// Katenoidaan merkkijonot
	for (int i=0; i<src.size; i++) 
		if (!src[i].isempty ()) {
			*this += src[i];
			if (i<src.size-1)
				*this += delim;
		}
	chksum=0;
}

String String::trim () const {
	int s=0, e=len;
	while (s<len && strchr (" \t\r\n",(*this)[s]))
		s++;
	while (e>s && strchr (" \t\r\n",(*this)[e-1]))
		e--;
	return substr (s, e-s);
}

void String::uppercase() const {
	for (int i=0; i<len; i++)
		data[i] = toupper (data[i]);
}

void String::lowercase() const {
	for (int i=0; i<len; i++)
		data[i] = tolower (data[i]);
}

// Suorittaa regular expression matchin merkkijonoon
int String::regmatch (const char* expr) const {
	if (!data)
		return 0;
	RegExp rexp (expr);
	return rexp.match (data);
}

// Toinen versio tukee parametreja regexpriss.
int String::regmatch (const char* expr, Array<String>& target) const {
	if (!data)
		return 0;
	RegExp rexp (expr);
	return rexp.match (*this, target);
}

int String::regmatch (RegExp& compiled, Array<String>& target) const {
	if (!data)
		return 0;
	return compiled.match (*this, target);
}

char String::checksum () {
	chksum=0;
	hashfunc (256);
	return chksum;
}


int	String::hashfunc (int hashsize) const {
	ASSERTWITH (hashsize<=256, format ("String hash size maximum is 256 slots",
									   " (hashsize was %d)", hashsize));
	
	// Jos on checksum laskettu, palautetaan sen mukainen arvo
	if (chksum)
		return chksum % hashsize;

	int sum=0;
	if (!len)
		return 0;

	if (len < 10) {
		// Lyhyille merkkijonoille
		
		for (int i=0; i<len; i++)
			sum += data[i];

		(unsigned char&) chksum = sum % 256;
	} else {
	// Pitemmille merkkijonoille

		// Sum of the first, middle and last character
		sum = int(data[0]) + int(data[len/2]) + len*int(data[len-1]);

		(unsigned char&) chksum = sum % 256;
	}

	// TRACE4 ("%s -> %d/%d/%d", data, sum, int(chksum), int(chksum%hashsize));
	return chksum % hashsize;
}

// Yksittisi funktioita


String format (const char* sformat, ...) {
	char format_buff[1024];
	va_list args;
	
	va_start (args, sformat);
	// fmt = va_arg(args, char*);
	int i=vsprintf (format_buff, sformat, args);
	va_end (args);

	ASSERTWITH (i<1024, "String format result exceeded buffer size (1024 bytes)");
	return format_buff;
}

// Hakee n-pituisesta merkkijonosta str merkin c,
// palauttaa osoittimen paikkaan tai NULL jos ei lydy
char* strnchr (const char* str, int len, char c) {
	const char* pos=str;
	for (int i=0; i<len; i++, pos++)
		if (*pos == c)
			return (char*) pos;
	return NULL;
}

// Lukee yhden \n-terminoidun rivin streamista String-merkkijonoon
int fgetS (FILE* in, String& str) {
	char	cbuff [4097],
			*nlpos;
	int len=0;

	str = "";

	do {
		// Luetaan yksi lohko
		fgets (cbuff, 4096, in);

		// Katsotaan onko lohkossa yhtn rivinvaihtoa
		nlpos = strnchr (cbuff, 4096, '\n');

		// Mritelln luetun lohkon pituus
		len = nlpos? nlpos-cbuff+1 : 4096;

		// Muunnetaan Stringiksi
		String tmp (cbuff, len);

		// Listn tulosmerkkijonoon
		str += tmp;

		// Toistetaan kunnes lydetn lohkosta rivinvaihto
	} while (!nlpos && !feof (in));

	if (feof (in))
		len = -1;

	return len;
}

istream& getS	(istream& is, String& str, char term) {
	str.len = 0; // Set size to 0. Warning! Uncommon access!
	if (str.getbuffer())
		str.getbuffer()[0] = '\x00';
	str.ensure_spontane (80);
	
	register streambuf *sb = is.rdbuf ();
	bool eof=false;
	while (true) {
		int ch = sb->sbumpc ();
		if (ch == EOF) {
			eof = true;
			is.setstate (ios::eofbit);
			break;
		} else
			// Separation with given character, or whitespace, if
			// the terminator is \xff.
			if ((term!='\xff' && ch==term) || (term=='\xff' && isspace (ch)))
				break;
		str += char(ch);
	}

	if (eof && str.len==0)
		is.setstate (ios::failbit);
	return is;
}

String::operator float () const {
	if (data) {
		char* tmp = strdup (data);
		for (char* tmp_p=tmp; *tmp_p; tmp_p++)
			if (*tmp_p == ',')
				*tmp_p = '.';
		float res = atof (tmp);
		free (tmp);
		return res;
	}
	return 0;
}

void nullcharspace (int charspace [256]) {
	for (int i=0; i<256; i++)
		charspace [i]=0;
}

// Mritelln tss nyt sitten tm emptystring
String emptystring;

// Emptystringille pit mys asettaa locked-bitti plle
// -> hoidetaan tm erikoisjipolla ;-)
//class Jippo1 {
//	Jippo1 () {emptystring.locked=1;}
//};
//Jippo1 jippo1;

void loadString (String& str, const String& filename) {
	FILE* in = fopen (filename, "rb");
	if (!in)
		return;
	str = "";
	String buff;
	buff.reserve (200);
	while (!feof(in)) {
		fgetS (in, buff);
		str += buff;
	}
	fclose (in);
}
