#ifndef __DEBUG_H__
#define __DEBUG_H__

#include "mconfig.h"

// Define may memory debugging extensions, unless disabled in config.h
#ifndef DISABLE_ALL_MEMORY_DEBUGGING

//#define new DEBUG_NEW
#define DEBUG_NEW new(__FILE__,__LINE__,__FUNCTION__)
#ifdef new
#undef new
#define new_UNDEFD
#define renew(p,ns) _renew (p,ns,__FILE__,__LINE__,__FUNCTION__)
#else
#define renew realloc
#warning "Renew is realloc"
#endif

extern void* operator new[] (size_t size, const char* filen, int lineno, const char* funcn);
extern void* operator new (size_t size, const char* filen, int lineno, const char* funcn);
extern void operator delete (void* p);
extern void list_allocations (int number=100, FILE* out=stderr);
extern void* _renew (void* p, size_t newsize, const char* filen, int lineno, const char* funcn);
extern "C" void newComment (const char* comment);

#ifdef new_UNDEFD
#define new DEBUG_NEW
#undef new_UNDEFD
#endif

struct mallocinfostr {
	char			startsym[6];
	int 			size;
	const char*		filename;
	int				lineno;
	const char*		funcname;
	char*			newcomment;
	bool			renewed;
	bool			isObject;
	mallocinfostr*	next;
	mallocinfostr*	prev;

	// This is required to corrent double-allocation word frame shift,
	// which results in BUS ERROR when writing to a double reference
	char			padding[4];
};

extern mallocinfostr* lastmalloced;		// The last malloced memory block
extern int dbgnewmalloced;				// Total amount of memory malloced

#else // DISABLE_ALL_MEMORY_DEBUGGING
// Some dummy function definitions

#include <stdlib.h>

inline void* _renew (void* p, size_t newsize, const char* filen, int lineno, const char* funcn) {
	return realloc (p, newsize);
}
#define renew(p,ns) _renew (p,ns,__FILE__,__LINE__,__FUNCTION__)

inline void newComment (const char* comment) {}

#endif // DISABLE_ALL_MEMORY_DEBUGGING

#endif
