#ifndef __DYNAMIC_H__
#define __DYNAMIC_H__

class Object;

class GetClassInstance {
  public:
    virtual Object*		getInstance	()=0;
};

#define CLONEMETHOD(cls) cls* clone () const {return new cls (*this);}
#define decl_clonable(classname) public: CLONEMETHOD (classname) private:

#define decl_dynamic(classname) \
	static Class class_##classname;\
  public:\
	virtual	const Class&	getclass	() const {return class_##classname;}\
  protected:

//    virtual Object*		getinstance	();

#define impl_dynamic(classname,bases) \
	class GetInstance_##classname : public GetClassInstance {\
	  public: Object* getInstance(){return new classname();}\
	};\
	Class	classname::class_##classname (#classname, #bases, new GetInstance_##classname());\

//    Object* classname::getinstance () {return new classname();}
//	Class	classname::class_##classname (#classname, #bases, (Object& (Object::*)()) (&classname::getinstance));
//	Class	classname::class_##classname (#classname, #bases, (const Object& (Object::*)()) (&classname::getinstance));

#define impl_abstract(classname,bases) \
	Class	classname::class_##classname (#classname, #bases, NULL);\

//    Object* classname::getinstance () {return NULL;}
//    Object& classname::getinstance () {return (Object&) *NULL;}
//	Class	classname::class_##classname (#classname, #bases, (Object& (Object::*)()) (&classname::getinstance));
//	Class	classname::class_##classname (#classname, #bases, (const Object& (Object::*)() const) (&classname::getinstance));

#define newobj(classname) \
	((classname*) & ClassLib::getinstance(#classname))

#define dyncreate(classname) \
	(&ClassLib::getinstance(classname))

//#define getInstance(classname) dyncreate(classname)

		
#endif
